      INTERFACE TO INTEGER*2 FUNCTION SYSTEM [C] (STRING[REFERENCE])
      CHARACTER*1 STRING
      END

       subroutine diskio(oper,unit,ioarea,fcb)
C      from sun 3/160c diskiech.f after PE diskiech.ftn
C      modified from Don Sawatzky's original source code
c
c      to make diskiono.for from diskio.for:
c           delete FILE='REMAPP.LOG' on remlog open statement subroutine
c                                                                       
c
C    TO MODIFY sun AND pc diskio's TO ACCEPT > 99,999 SCANLINES
c         (up to > 999,999):
c    1) mod open (fbc(1)=0) 2 read statements:
c          read fcb(1-7)   15x,i6  (instead of 16xi5)
c          read fcb(12-30) 15x,i6
c     2) mod open (fcb(1)=>0) format statement 99
c          change all i5's to i6
c          reduce all char descript's to 15 char instead of 16
c      (5 ':' need to be deleted (occupy's the same pos as i6)& rest spaces)
c
c
c  .. diskio will create or read remapp type disk files
c                                                                       
c  .. files created with this diskio will have 1 or more channels       
c     and must be read with this diskio.                                
c                                                                       
c..........                                                             
c     operations                                                        
c                                                                       
c     oper=0 - open an input or output file or read/write file.     
c          1 - set new window in opened input file                     
c          2 - open input file in fcb in ioarea to new fcb             
c          3 - rewind, point to first data record                       
c          4 - skip no. records specified in fcb(1)                     
c          5 - backspace no. records specified in fcb(1)                
c          6 - close a file                                             
c          9 - read record into array ioarea                            
c          10 - write record from array ioarea                   
c          11 - read record no. specified in fcb(1) into array ioarea   
c               but points to following record after read.
c          12 - read a record of output file without advancing record   
c               pointer.  Use present fcb(14) or change it before read.
c          13 - write array to output file at record in fcb(14).        
c               Works well after operation=12.
c                                                                       
c....................                                                   
c                                                                       
c     unit = integer fortran logical unit no. assigned to file          
c
c            unit #      = filename\data
c            unit # + 50 = filename\header
c                                                                       
c....................                                                   
c                                                                       
c     ioarea = integer or logical array dimensioned to contain          
c            enough bytes to hold one file record                       
c                                                                       
c..............................                                         
c     remapp file control block definitions                             
c                                                                       
c     fcb = integer array dimensioned to 256 (1024 bytes)  
c     word 1 - on oper=0,1,2,
c                        = -1 open existing file for read/write
c                        = 0 open existing file for read/write
c                          /* Note: future version will be - read only */
c                        => 8 create/open output file with bits/pixel 
c            on oper=4,5 has no. of records to space                   
c            on oper=11, no. of record to read                         
c            upon return has status                                    
c                  status=0 - no error                                 
c                  status=-1 - end of file or media                     
c                  status=-2 - i/o error                                
c     word 2 - on open for output file has no. of pixels/scanline       
c            on open input file returns pixels/scanline window          
c     word 3 - on open for output file has no. of scanlines per band    
c            necessary if output file is elas type.                     
c            on open input returns no. of scanlines window.             
c     word 4 - for input file contains first pixel to read              
c     word 5 - for input file contains first scanline to read           
c     word 6 - for input file contains pixel skip factor                
c     word 7 - for input file contains scanline skip factor             
c     words 8,11 - filename in ascii                                    
c     word 12 - record length in bytes                                  
c     word 13 - no. of bands                                            
c     word 14 - current data record no., header record no.=0            
c     word 15 - 0 = remapp
c               no. pixels/window on open (temporary)                   
c     word 16 - no. lines/window on open                                
c     word 17 - =0 use standard open prompt                             
c             <>0 use prompt string in ioarea   /* not enabled yet */
c     word 18 - record no. of first scanline                            
c     word 19 - record increment                                        
c     word 20 - volumename of file                                      
c     word 21 - 0 for input, 1 for output                               
c     word 22 - if all channels read = 1; else  = fcb(13)               
c     word 23 - no. of pixels/scanline                                  
c     word 24 - no. of records/file                                     
c     word 25 - bits/pixel                                              
c     word 26 - no. of last scanline in window                          
c     word 27 - no. of last pixel in window                             
c     word 28 - band no. to input; if -1 input all bands.               
c     word 29 - actual logical record length                            
c     word 31 - temporary file descriptor
c     word 32-256 - file history in ascii                               
c............................................................           
c     to open a remapp output file must pass                            
c     fcb 1,2, and 13
c
c     and dimension and initialize all fcbs:                            
c     integer*4 fcb(256)/256*0/                                         
c............................................................
c
      character*1 ioarea(1)
      integer*2 ixx, SYSTEM
      integer*4 fcb(256),oper,unit,ttyin,ttyout,isize,opentype
      character filedesc*64,filename*80,filenm*16,string*64
      integer*4 code
      common/discom/ istat,filenm,i,ifc,isize,code,j,jump,              
     & k,kend,kinc,kmul,kst,l,ll,nbytes,ttyin,ttyout         
     & ,filedesc,string,m,n,ifsize,ibsize
C      iblank is assigned to fcb(20) /* volume name of file */
       iblank = '                '
c
c...job starts                                                          
c                                                                       
c  entry point and branch vector to operation routines                  
c                                                                       
      jump=oper+1                                                       
      if(jump.gt.14.or.jump.lt.1) goto 5                                
c     ioper = 0  1  2  3   4   5   6  7 8  9   10  11  12  13
      go to (30,65,30,100,110,120,200,5,5,140,190,130,140,190)jump      
5     write(6,10)                                                       
10    format(1x,'Diskio: invalid operation code')                        
      stop
c
20    return                                                            
c                                                                       
c  file opening procedures                                              
30    continue
c.....if reopen to new fcb, get copy of open fcb to new fcb             
C      if(oper.eq.2) then                                                
C      call copyfcb(ioarea,fcb)                                          
C      write(6,*) ' '                                                    
C      write(6,*) 'opening file again.'                                  
C      goto 500                                                          
C      endif                                                             
c.....give remapp standard prompt                                       
      if(fcb(17).eq.0) then                                             
      if(fcb(1).le.0) write(6,11)                                      
11    format('+',' Diskio: enter input filename',/,' ',\)
      if(fcb(1).gt.0)write(6,12)                                        
12    format(1x,'Diskio: enter output filename')                       
      else                                                              
c.....use prompt passed by program                                      
C      write(string,'(64a1)') (ioarea(i),i=1,64)                         
C      write (6,*) 'Diskio: '//string(1:index(string,'$')-1)           
C      fcb(17)=0
      endif                                                             
c.....read file descriptor                                              
      read(5,'(a64)') filedesc                                           
c.....parse PC-DOS file descriptor
        n1 = 0
        do 121 i=1,64
           if(filedesc(i:i).eq.'\' .or. filedesc(i:i).eq.':') n1=i
121     continue
      n2=0
      do 122 n3=len(filedesc),1,-1
         if (filedesc(n3:n3) .eq. ' ') n2=n3
122   continue
C
      filenm = filedesc(n1+1:n1+12)
C
c.....move filename to fcb                                              
      read(filenm,'(4a4)') (fcb(i),i=8,11)                              
c.....goto read or write open
      opentype=fcb(1)
      if(fcb(1).gt.0) goto 80             
c                                                                       
c  open input file                                                      
c                                                                       
c  open header file
      filename=filedesc(1:n2-1)//'\header'
      unit = unit + 50
      open(unit,file=filename,
     & iostat=code,status='old')
      if(code.ne.0) write(6,399) code                                   
399   format(/1x,'Diskio:  open error = ',i3)                            
      if(code.ne.0)go to 300                                            
c.....read header                             
      read(unit,fmt='(16x,a6)') string
      if(string.ne.'REMAPP') then
      write(6,*) 'Not a REMAPP file!!'
      goto 300
      endif
      read(unit,fmt='(16x,i5)',iostat=code) (fcb(i),i=1,7)
      if(code.ne.0) goto 300
      read(unit,fmt='(16x,4a4)',iostat=code) (fcb(i),i=8,11)
      if(code.ne.0) goto 300                                           
      read(unit,fmt='(16x,i5)',iostat=code) (fcb(i),i=12,30)
      if(code.ne.0) goto 300                                           
c.....close header file
      unit = unit - 50
c.....open input data file : fcb(31)=unit # of \header
      fcb(31) = unit + 50
      filename=filedesc(1:n2-1)//'\data'
      open(unit,file=filename,FORM='BINARY',
     & iostat=code,status='old',access='direct',recl=fcb(12))
      if(code.ne.0) goto 300
c.....remapp file                                                       
c.....set default no. of bands to 1                                     
500   if(fcb(13).eq.0) fcb(13)=1                                        
c      write(6,70) (fcb(i),i=8,11),fcb(24)/fcb(13),fcb(23),fcb(25),      
c     & fcb(13)                                                          
      if(fcb(18).lt.1) fcb(18)=1                                                         
      fcb(19)=1                                                         
      write(6,61)                                                       
61    format(1x,' enter 1st sl, no. sl/band, skips, band',/,' ',\)
      read(5,*) fcb(5),fcb(16),fcb(7),fcb(28)             
      write(6,62)                                                       
62    format(1x,'enter 1st pixel, no. pixels, skips: ',/,' ',\)
      read(5,*) fcb(4),fcb(15),fcb(6)                         
c.....set new window to opened file                                     
65    if(fcb(28).lt.0) then                                             
      fcb(22)=1                                                         
      else                                                              
      fcb(22)=fcb(13)                                                   
      endif                                                             
      iline = fcb(5)                                                    
      if(iline.lt.1) iline=1                                            
      nlines = fcb(16)                                                  
      if(nlines.lt.1) then                                              
      nlines=fcb(24)/fcb(22) - iline +1                                 
      else                                                              
      nlines = min(nlines,fcb(24)/fcb(22) - iline +1)                   
      endif                                                             
      nlskips = fcb(7)                                                  
c.....adjust line skip factor for band                                  
      fcb(7)=fcb(22)*(nlskips+1) -1                                     
c.....adjust no. of lines for no. of bands                              
      fcb(16)=nlines*fcb(22)                                            
c.....default starting values                                           
      if(fcb(28).lt.1) fcb(28)=1                                        
      if(fcb(28).gt.fcb(13)) fcb(28)=fcb(13)                            
      fcb(5)=fcb(22)*(iline-1) + fcb(28)                                
      if(fcb(4).le.0) fcb(4)=1                                          
c.....starting values too large?                                        
      if(fcb(4).gt.fcb(23)) fcb(4)=fcb(23)                              
      if(fcb(5).gt.fcb(24)) fcb(5)=fcb(24)                              
c.....nos. too large?                                                   
      if(fcb(4)+fcb(15)-1.gt.fcb(23)) fcb(15)=fcb(23)-fcb(4)+1          
      if(fcb(5)+fcb(16)-1.gt.fcb(24)) fcb(16)=fcb(24)-fcb(5)+1          
c.....default window lengths                                            
      if(fcb(15).le.0) fcb(15)=fcb(23)-fcb(4)+1                         
      if(fcb(16).le.0) fcb(16)=fcb(24)-fcb(5)+1                         
c.....last record                                                       
      fcb(26)=fcb(5)+fcb(16)-1                                          
      if(fcb(26).gt.fcb(24)) fcb(26)= fcb(24)                           
c.....first record                                                      
      fcb(14)=fcb(19)*(fcb(5)-1)+fcb(18)                                
c.....last pixel                                                        
      fcb(27)=fcb(4)+fcb(15)-1                                          
      if(fcb(27).gt.fcb(23)) fcb(27)=fcb(23)                            
c.....actual no. pixels and scanlines                                   
      fcb(2)=(fcb(15)-1)/(fcb(6)+1)+1                                   
      fcb(3)=(nlines-1)/(nlskips+1)+1                                   
c     fcb(3)=(fcb(16)-1)/(fcb(7)+1)+1                                   
c                                                                       
70    format(1x,'Diskio(2):',4a4,'[lines/band ',i5,                    
     *' pixels ',i5,' bytesize ',i2,' bands ',i4']')          
      fcb(21)=0                                                         
      write(4,72) (fcb(i),i=8,11)                                       
c      write(6,72) (fcb(i),i=8,11)                                       
72    format(1x,'input file ',4a4,' opened:')                           
c     lactual = (nlines-1)/(nlskips+1)+1                                
      write(4,71) fcb(28),iline,nlines,nlskips,fcb(3),fcb(4),fcb(15),
     & fcb(6),fcb(2)                                                   
c      write(6,71) fcb(28),iline,nlines,nlskips,fcb(3),fcb(4),fcb(15),
c     & fcb(6),fcb(2)                                                   
71    format(1x,'window',t26,'  band',t32,'   1st',t38,'   no.',
     * t44,'  skip',t50,' actual',/,
     * 1x,'lines',t26,4i6,1x,i6/                       
     *,1x,'pixels',t32,3i6,1x,i6)                               
      fcb(21)=0                                                         
      fcb(1)=0
      go to 20                                                          
c                                                                       
c open an output file                                                   
c                                                                       
80    continue

      fcb(4)=1                                                          
      fcb(5)=1                                                          
      fcb(6)=0                                                          
      fcb(7)=0                                                          
      fcb(13)=max(1,fcb(13))                                            
      fcb(14)=1                                                         
      fcb(18)=1                                                         
      fcb(19)=1                                                         
      fcb(20)=iblank
      fcb(21)=1                                                         
      fcb(23)=fcb(2)                                                    
      fcb(24)=0                                                         
      fcb(25)=fcb(1)                                                    
      fcb(26)=0                                                         
      fcb(12)=fcb(23)*fcb(25)/8                                         
      fcb(27)=fcb(2)                                                    
      fcb(28)=1                                                         
c.....create remapp file
      filename=filedesc(1:n2-1)
      ixx = SYSTEM('mkdir '//filedesc//''C)
C
      filename=filedesc(1:n2-1)//'\header'
      unit = unit + 50
      open(unit,file=filename,
     & iostat=code,status='new')
      if(code.ne.0) write(6,398) code                                   
398   format(1x,'Diskio:  create error = ',i3)
      if(code.ne.0)go to 300                                            
c.....write file header                                                 
      write(unit,fmt=99,iostat=code) (fcb(i),i=1,30)
99    format(
     &       'Image ProcSys:  REMAPP'/
     &       'Parameter:      ',i5/'No. pixels:     ',i5/
     &       'No. scanlines:  ',i5/'First pixel:    ',i5/
     &       'First scanline: ',i5/'Pixel skip:     ',i5/
     &       'Scanline skip:  ',i5/'File name:      ',4a4/
     &       'reclen in bytes:',i5/'no. of bands:   ',i5/
     &       'current rec no.:',i5/'word no. 15     ',i5/
     &       'word no. 16     ',i5/'word no. 17     ',i5/
     &       'band 1st line:  ',i5/'band increment: ',i5/
     &       'volume name     ',a5/'word no. 21     ',i5/
     &       'word no. 22     ',i5/'no. pixels/line:',i5/
     &       'no. recs/file:  ',i5/'bits/pixel:     ',i5/
     &       'no.last scl/win:',i5/'no.last pxl/win:',i5/
     &       'word no. 28:    ',i5/'word no. 29:    ',i5/
     &       'word no. 30:    ',i5)
C.....close(unit)
      unit = unit - 50
c.....open output data file to unit
      fcb(31) = unit + 50
c     nbytes=fcb(12)
      filename=filedesc(1:n2-1)//'\data'                                           
      open(unit,file=filename,
     & access='direct',recl=fcb(12),form='BINARY',status='new',
     & iostat=code)
      if(code.ne.0) goto 300                                           
      fcb(1)=0
      go to 20                                                          
c                                                                       
c  rewind - point to first data record                                  
100   fcb(14)=(fcb(5)-1)*fcb(19) + fcb(18)                              
      fcb(1)=0                                                          
      go to 20                                                          
c                                                                       
c  skip specified number of records
110   fcb(14)=fcb(14)+fcb(1)*fcb(19)*fcb(22)                            
      go to 20                                                          
c                                                                       
c  backspace specified number of records                                
c                                                                       
120   fcb(14)=fcb(14)-fcb(1)*fcb(19)*fcb(22)                            
      go to 20                                                          
c                                                                       
c  read a specific record                                               
c                                                                       
130   fcb(14)=(fcb(1)+fcb(5)-2)*fcb(19)*fcb(22) + fcb(18)                 
      go to 140                                                         
c                                                                       
c read a record                                                    
c                                                                       
140   fcb(1)=0                                                          
      if(fcb(14).lt.(fcb(5)-1)*fcb(19) + fcb(18)) goto 300              
      if(fcb(14).le.(fcb(26)-1)*fcb(19) + fcb(18)) go to 142            
      write(6,180)(fcb(i),i=8,11)                                       
180   format(1x,'Diskio: end of file on ',4a4)                           
      fcb(1)=-1                                                         
      go to 20                                                          
c.....read,direct,unformatted input file                           
142   continue
c      read(unit,rec=fcb(14),iostat=code) (ioarea(i),i=1,fcb(12))
c  pass array to subroutine rather than implied do loop (much much faster)
c
      code = fcb(12)
      call reada(unit,code,ioarea,fcb)
      if(code.ne.0) goto 300
c                                                                       
c  extract a subset of line if desired                                  
c                                                                       
      if(fcb(4).eq.1.and.fcb(6).eq.0)go to 160                          
      i=1                                                               
      kmul=fcb(25)/8                                                    
      kst=(fcb(4)-1)*kmul +1                                            
      kend=(fcb(27)-1)*kmul +1                                          
      kinc=(fcb(6)+1)*kmul                                              
      do 150 k=kst,kend,kinc                                            
      do 150 j=k,k+kmul-1                                               
      ioarea(i)=ioarea(j)                                               
150   i=i+1                                                             
c.....don't point to next record if oper=12                             
160   if(oper.eq.9) fcb(14)=fcb(14)+(1+fcb(7))*fcb(19)                  
      goto 20                                                           
c                                                                       
c write a record                                                        
c                                                                       
190   continue                                                          
      if(oper.eq.10) then                                               
c.....write output file
c      write(unit,rec=fcb(14),iostat=code)(ioarea(i),i=1,fcb(12))
c
      code = fcb(12)
      call writea(unit,code,ioarea,fcb)
      if(code.ne.0) goto 300                                           
      fcb(14)=fcb(14)+fcb(19)                                           
      fcb(24)=fcb(14)-1                                                 
      fcb(3)=fcb(24)                                                    
      fcb(26)=fcb(24)                                                   
      else                                                              
c.....random write
c      write(unit,rec=fcb(14),iostat=code)(ioarea(i),i=1,fcb(12))
c
      code = fcb(12)
      call writea(unit,code,ioarea,fcb)
      if(code.ne.0) goto 300                                           
      fcb(14)=fcb(14)+fcb(19)                                           
      endif                                                             
      fcb(1)=0
      go to 20                                                          
c                                                                       
c  close a file   /* fcb(21)=0 : input file  */
c                 /* fcb(21)>0 : output file */
200   if(fcb(21).le.0) then
C     UNIT = filename\DATA; UNIT+50 = filename\HEADER
      CLOSE(unit)
      unit = unit + 50
      CLOSE(unit)
      unit = unit - 50
      else
c                                                                       
c  close output data file - write fcb
C.....close filename\DATA
      CLOSE(unit)
c                                                                       
c.....remapp file close                                                 
      fcb(2)=fcb(23)                                                    
      fcb(3)=fcb(24)                                                    
c.....update remapp header file
      unit = unit + 50
      rewind(unit)
      write(unit,fmt=99,iostat=code) (fcb(i),i=1,30)
      if(code.ne.0) goto 300                                           
201   close(unit,iostat=code)
      if(code.ne.0)go to 300                                            
      unit = unit - 50
      write(4,202)                                                      
202   format(1x,t15,'output file closed:')                              
      write(4,70)(fcb(i),i=8,11),fcb(24)/fcb(13),fcb(23),fcb(25),       
     & fcb(13)                                                          
      write(6,70)(fcb(i),i=8,11),fcb(24)/fcb(13),fcb(23),fcb(25),       
     & fcb(13)                                                          
      endif
      fcb(1)=0
      go to 20                                                          
c                                                                       
c  finis                                                                
c                                                                       
300   fcb(1)=-2                                                         
      write(6,*) 'Error code: ',code
      go to 20                                                          
      end
c
      block data discommon                                              
      character filedesc*64,filenm*16,string*64
      common/discom/ istat,filenm,i,ifc,isize,code,j,jump,              
     & k,kend,kinc,kmul,kst,l,ll,nbytes,ttyin,ttyout         
     & ,filedesc,string,m,n,ifsize,ibsize                          
      data ttyin/5/,ttyout/6/                                           
      end
c
c
c
      subroutine reada(unit,code,ioarea,fcb)
      integer*4 fcb(256),unit,code
      character*1 ioarea(code)
c
c     fcb(12) = bytes/record  (code - input)
c     fcb(14) = record # to read or write
c
      read(unit,rec=fcb(14),iostat=code) ioarea
      return
      end
c
c
c
      subroutine writea(unit,code,ioarea,fcb)
      integer*4 fcb(256),unit,code
      character*1 ioarea(code)
c
      write(unit,rec=fcb(14),iostat=code) ioarea
      return
      end
c
c
c
C      subroutine copyfcb(nfcb,fcb)                                    
C      integer nfcb(256),fcb(256)                                      
C      do 1 i=1,256                                                      
C 1     fcb(i)=nfcb(i)                                                  
C      return                                                            
C      end
c
C      integer function length(s)
C      character s*(*)
C      do 1 length=len(s),1,-1
C 1     if(s(length:length).ne.' ') return
C      length=0
C      return
C      end

      SUBROUTINE REMLOG(TITLE)
C       INCLUDE 'REMAPP.HDR'
C       LOGS FILE INTERACTIONS TO REMAPP.LOG
C       LINK WITH DATE,TIME,EXIT
      LOGICAL LUOPEN
      CHARACTER*4 IDATE(3),ITIME(3)
      CHARACTER TITLE*(*)
      INQUIRE(4,OPENED=LUOPEN)
      IF(.NOT.LUOPEN) THEN
         OPEN(4,STATUS='UNKNOWN',FORM='FORMATTED',
     &   RECL=128,IOSTAT=ISTAT,ACCESS='SEQUENTIAL')
         IF(ISTAT.NE.0) THEN
            WRITE(6,*)' UNABLE TO OPEN LOG FILE. STATUS = ',ISTAT
            CALL EXIT(255)
         ENDIF
      ENDIF
      CALL DATE(IDATE)
      CALL TIME(ITIME)
10    READ (4,*,END=20)
      GOTO 10
20    CONTINUE
      BACKSPACE(4)
      WRITE(4,*)
      WRITE(4,*)
      WRITE(4,*) 'REMAPP PC IMAGE PROCESSING SYSTEM - U. S. G. S.'
      WRITE(4,9) IDATE,ITIME,TITLE
9     FORMAT(1X,3A4,3A4,'---- ',A,' ----')
      RETURN
      END

      SUBROUTINE DATE(IDATE)
      CHARACTER*4 IDATE(3)
      INTEGER*2 IYR,IMON,IDAY
      CALL GETDAT(IYR,IMON,IDAY)
      IDATE(1)='  ' // CHAR(IMON/10+48) // CHAR(MOD(IMON,10)+48)
      IDATE(2)='/' // CHAR(IDAY/10+48) // CHAR(MOD(IDAY,10)+48) // '/'
      IDATE(3)=CHAR(IYR/1000+48) // CHAR(MOD(IYR/100,10)+48) //
     * CHAR(MOD(IYR/10,10)+48) // CHAR(MOD(IYR,10)+48)
      RETURN
      END

      SUBROUTINE TIME(ITIME)
      CHARACTER*4 ITIME(3)
      INTEGER*2 IHR,IMIN,ISEC,I100TH
      CALL GETTIM(IHR,IMIN,ISEC,I100TH)
      ITIME(1)='  ' // CHAR(IHR/10+48) // CHAR(MOD(IHR,10)+48)
      ITIME(2)=':' // CHAR(IMIN/10+48) // CHAR(MOD(IMIN,10)+48) // ':'
      ITIME(3)=CHAR(ISEC/10+48) // CHAR(MOD(ISEC,10)+48)
      RETURN
      END

      SUBROUTINE EXIT(IOERROR)
      INTEGER*4 IOERROR
      WRITE (*,*) IOERROR
      STOP 'STOPPED AT ERROR - EXIT SUBROUTINE'
      RETURN
      END
