      PROGRAM ARITH
C ***********************************************************
C *   DOES MATH OPERATION ON FILES SELECTED BELOW
C *   apply multiple and additive constants (alpha & beta)
C *   multiply or add image files together
C *      INPUT FILES: 8 OR 16 BITS/PIXEL
C *      OUTPUT FILES: 16 BITS/PIXEL
C *      Band Ratio divides by 0; output DN = 32766
C *
C *   LINK WITH DISKIO,UNPACK
C *
C ***********************************************************
C
      INTEGER*4 FCBA(256),FCBB(256),FCBC(256),ALGOR, ILIM
      INTEGER*2 ABUF(8192),BBUF(8192),MAXNUM
      INTEGER*2 CBUF(8192)
      REAL*4 ALPHA, BETA, GAMMA, ALPHAA, ALPHAB, A, B, RMAXNM, IC
      MAXNUM=32766
      RMAXNM=MAXNUM
C...DOCUMENTATION FOR A JOB
      CALL REMLOG('* * * * *    ARITH   * * * * * ')
C...JOB STARTS
10    WRITE(6,20)
20    FORMAT(/' SELECT ONE OF THE FOLLOWING ALGORITHMS:'/
     #  ' (WHERE FILEA, FILEB, AND FILEC ARE DATA FILES,'/
     #  '  AND ALPHA AND BETA ARE REAL CONSTANTS.)'//
     #'  1. (ALPHAA * FILEA) + (ALPHAB * FILEB) + BETA'/
     #'  2. (ALPHA * FILEA * FILEB) + BETA'/
     #'  3. (ALPHA * (FILEA/FILEB)) + BETA'/
     #'  4. (ALPHAA * FILEA) + BETA'/
     #'  5. (ALPHA * LOG(GAMMA * FILEA)) + BETA'/
     #'  6. (ALPHA * EXPONENTIAL(GAMMA * FILEA)) + BETA'/)
      WRITE(6,11)
11    FORMAT(' SELECT ALGORITHM 1,2,3,4,5, OR 6.   *')
      READ(5,30)ALGOR
30    FORMAT(I4)
C...DOCUMENTATION FOR A JOB
      WRITE(4,13) ALGOR
13    FORMAT(' THE SELECTED AGORITHM IS NUMBER',I4)
      IF(ALGOR.LT.1.OR.ALGOR.GT.6)GO TO 10
C
C  CLEAR FILE CONTROL BLOCKS
      DO 40 I=1,256
        FCBA(I)=0
        FCBB(I)=0
40      FCBC(I)=0
C
C  OPEN INPUT FILES
C...DOCUMENTATION FOR A JOB
      FCBA(1)=0
      WRITE(4,50)
      WRITE(6,50)
50    FORMAT(/' FILEA:')
      CALL DISKIO(0,8,ABUF,FCBA)
      IF(FCBA(1).LT.0) CALL EXIT(3)
      IF(ALGOR.GE.4) GO TO 65
C...DOCUMENTATION FOR A JOB
      FCBB(1)=0
      WRITE(4,60)
      WRITE(6,60)
60    FORMAT(/' FILEB:')
      CALL DISKIO(0,9,BBUF,FCBB)
      IF(FCBB(1).LT.0) CALL EXIT(3)
C
C  OPEN THE OUTPUT FILE
65    FCBC(1)=16
      FCBC(2)=FCBA(2)
      IF(FCBA(22).GT.1) THEN
         FCBC(13) = 1
      ELSE
         FCBC(13) = FCBA(13)
      ENDIF
      CALL DISKIO(0,12,CBUF,FCBC)
      IF(FCBC(1).LT.0) CALL EXIT(3)
C
C  GET REAL CONSTANTS
      IF(ALGOR.EQ.1) GO TO 85
      IF(ALGOR.GT.4) GO TO 851
      WRITE(6,80)
80    FORMAT(/' ENTER ALPHA AND BETA *')
      READ(5,*)ALPHA,BETA
C...DOCUMENTATION FOR A JOB
      WRITE(4,82) ALPHA,BETA
82    FORMAT(' THE CONSTANTS ALPHA AND BETA ARE'2F8.2)
      GO TO 90
C   GET CONSTANTS FOR ALGOR > 4
851   WRITE(6,852)
852   FORMAT(' ENTER ALPHA, GAMMA, AND BETA *')
      READ(5,*) ALPHA,GAMMA,BETA
C...DOCUMENTATION FOR JOB
      WRITE(4,853) ALPHA,GAMMA,BETA
853   FORMAT(' THE CONSTANTS ALPHA, GAMMA, AND BETA ARE',3F6.2)
      GOTO 90
C   GET CONSTANTS FOR ALGOR=1
85    WRITE(6,83)
83    FORMAT(' ENTER ALPHAA, ALPHAB, AND BETA *')
      READ(5,*) ALPHAA,ALPHAB,BETA
C...DOCUMENTATION FOR A JOB
      WRITE(4,84) ALPHAA,ALPHAB,BETA
84    FORMAT(' THE CONSTANTS ALPHAA, ALPHAB, AND BETA ARE',3F6.2)
90    CONTINUE
C  PROCEED WITH ARITHMETIC PROCESSING
      ILIM=FCBA(2)
      IF(ALGOR.GE.4) GO TO 101
100   CALL DISKIO(9,9,BBUF,FCBB)
      IF(FCBB(1).LT.0) GOTO 180
      IF(FCBB(25) .EQ. 8) CALL UNPACK(BBUF,FCBB)
101   CALL DISKIO(9,8,ABUF,FCBA)
      IF(FCBA(1).LT.0) GOTO 180
      IF(FCBA(25) .EQ. 8) CALL UNPACK(ABUF,FCBA)
      GO TO (110,130,150,400,500,600)ALGOR
C  LINEAR TRANSFORM OF A FILE
400   DO 410 I=1,ILIM
         CBUF(I) = INT2((ALPHA*REAL(ABUF(I))) + BETA + 0.5)
         IF(CBUF(I).LT.0) CBUF(I)=0
         IF(CBUF(I).GT.MAXNUM) CBUF(I)=MAXNUM
410   CONTINUE
      GO TO 170
C
C  ADD TWO FILES
110   DO 120 I=1,ILIM
         CBUF(I)=INT2((ALPHAA*REAL(ABUF(I))) + (ALPHAB*REAL(BBUF(I)))
     &      + BETA + 0.5)
         IF(CBUF(I).LT.0) CBUF(I)=0
         IF(CBUF(I).GT.MAXNUM) CBUF(I)=MAXNUM
120   CONTINUE
      GO TO 170
C
C     PRODUCT OF TWO FILES
130   DO 140 I=1,ILIM
         CBUF(I)=INT2(ALPHA*(REAL(ABUF(I))*REAL(BBUF(I))) + BETA + 0.5)
         IF(CBUF(I).LT.0) CBUF(I)=0
         IF(CBUF(I).GT.MAXNUM) CBUF(I)=MAXNUM
140   CONTINUE
      GO TO 170
C
C  RATIO TWO FILES
150   DO 160 I=1,ILIM
         IF(BBUF(I).EQ.0) GO TO 159
         A=REAL(ABUF(I))
         B=REAL(BBUF(I))
         IC=(ALPHA*(A/B))+BETA+0.5
         CBUF(I)=INT2(MIN(IC,RMAXNM))
         IF(CBUF(I).LT.0) CBUF(I)=0
         GO TO 160
159      CBUF(I)=MAXNUM
160   CONTINUE
      GOTO 170
C
C  LOG (Base 10) TRANSFORM OF A FILE
500   DO 510 I=1,ILIM
         B=GAMMA * REAL(ABUF(I))
         IF(B .LT. 1.0) B=1.0
         A=(ALPHA * LOG10(B)) + BETA + 0.5
         IF(A .LT. 0.0) A=0.0
         IF(A .GT. RMAXNM) A=RMAXNM
510      CBUF(I) = INT2(A)
      GOTO 170
C
C  EXPONENTIAL TRANSFORM OF A FILE
600   DO 610 I=1,ILIM
         B=GAMMA * REAL(ABUF(I))
         IF(B .GT. 88) B=88
         A=(ALPHA * EXP(B)) + BETA + 0.5
         IF(A .LT. 0.0) A=0.0
         IF(A .GT. RMAXNM) A=RMAXNM
610      CBUF(I) = INT2(A)
      GOTO 170
C
C  WRITE THE RESULT FILE
170   CALL DISKIO(10,12,CBUF,FCBC)
      IF(FCBC(1).LT.0) STOP
      GO TO (100,100,100,101,101,101) ALGOR
C
C  CLOSE THE FILES
180   CALL DISKIO(6,8,ABUF,FCBA)
      IF(ALGOR.GE.4) GO TO 182
      CALL DISKIO(6,9,BBUF,FCBB)
182   CALL DISKIO(6,12,CBUF,FCBC)
      WRITE(6,190)
190   FORMAT(/' CONTINUE (Y,N) ? ')
      READ(5,200)IGO
200   FORMAT(1A1)
      IF((IGO.EQ.'Y').OR.(IGO.EQ.'y')) GO TO 10
      STOP
      END
