      program badline
c  ******************************************************************
c  *
c  *  program replaces bad scanlines with linearly interpolated
c  *     pixels from the scanline above and below
c  *
c  *  it is capable of handling consecutive bad lines
c  *    and may store up to 100 starting bad lines
c  *
c  *  starting bad lines must be entered in order from top to bottom
c  *      sl=1 and sl=last scanline not accepted by read (gens warning)
c  *
c  *  BIL output files not supported
c  *
c  *
c  *  K. E. Livo       Jan. 1993
c  *
c  *  link with DISKIO, PACK, and UNPACK
c  *
c  ******************************************************************
 
      integer*2 ibuf(8192), tbuf(8192), t2buf(8192)
      integer*4 ifcb(256), ofcb(256)
      integer*4 sl, pix, i, slloop, nbadi, nbsli, bslmax
      integer*4 bsl(100), nbsl(100)
      character*1 ans
 
      data ifcb,ofcb/256*0,256*0/
      data bsl,nbsl/100*0,100*0/
 
c  log it
 
      call remlog('*****  --  badline  --  *****')
 
c  open input
 
      ifcb(1)=0
 
      call diskio(0,11,ibuf,ifcb)
      if (ifcb(1).lt.0) call exit(1)
 
c  open output
 
      ofcb(1) = ifcb(25)
      ofcb(2) = ifcb(2)
      if(ifcb(22).gt.1) then
         ofcb(13) = 1
      else
         ofcb(13) = ifcb(13)
      endif
 
      call diskio(0,12,ibuf,ofcb)
      if (ofcb(1).lt.0) call exit(2)
 
c  enter starting scanlines of bad lines into array
c     set bslmax = 1 prevents setting scanline 1 as bad line
c     checks for bad line >= EOF; prevents EOF as bad line
 
      write(6,*)
      write(6,*) '            *****',
     &           '************************************************'
      write(6,*)
      write(6,*) '                 ',
     &           'List BAD LINES in order: from top to bottom'
      write(6,*)
      write(6,*) '            *****',
     &           '************************************************'
 
      bslmax = 1
      i = 1
      ans = 'y'
 
      do while (ans .ne. 'n')
 
         write(6,*)
         if (i.eq.1) write(6,100)
         if (i.gt.1) write(6,101)
CBSD4100      format(1x,'Enter first Bad Scanline:  ',$)
CMSPC100      format(1x,'Enter first Bad Scanline:  ',\)
100      format(1x,'Enter first Bad Scanline:  ',\)
CBSD4101      format(1x,'Enter next Bad Scanline:  ',$)
CMSPC101      format(1x,'Enter next Bad Scanline:  ',\)
101      format(1x,'Enter next Bad Scanline:  ',\)
 
         read(5,*) bsl(i)
 
         if(bslmax .lt. bsl(i)) then
            if(ifcb(3) .gt. bsl(i)) then
               write(6,110) bsl(i)
110            format(1x,
     & 'Enter number of consecutive Bad Lines starting at Scanline',I7,
CBSD4     & ' :  ',$)
CMSPC     & ' :  ',\)
     & ' :  ',\)
               read(5,*) nbsl(i)
               bslmax = bsl(i) + nbsl(i)
               write(4,*) 'bad scanline ',bsl(i),';  number of lines ',
     &            nbsl(i)
               i = i + 1
            else
               write(6,*)
     &         'Bad Scanline ENTERED is PAST End of File',ifcb(3)
            endif
         else
            write(6,*)
     &     'Bad Scanline ENTERED must be GREATER than scanline',bslmax
         endif
 
         write(6,120)
CBSD4120      format(1x,'Enter more Bad Scanlines (Y/N):  <y> default:  ',$)
CMSPC120      format(1x,'Enter more Bad Scanlines (Y/N):  <y> default:  ',\)
120      format(1x,'Enter more Bad Scanlines (Y/N):  <y> default:  ',\)
         read(5,'(A1)') ans
         if (ans.eq.'N') ans = 'n'
 
      enddo
 
      nbadi = i -1
 
c  read & write up to 1st bad line
c     read cannot handle bad line as first record
 
      sl = 1
 
c  jump to end if no bad lines
 
      if (nbadi.eq.0) goto 990
 
      do 200 i=1, nbadi
 
         if(sl.eq.bsl(i)) then
cver3            call unpack(tbuf,ofcb)
            if(ofcb(25).eq.8) call unpack(tbuf,ofcb)
            do 210 slloop=1, ifcb(2)
               ibuf(slloop) = tbuf(slloop)
cver2 only; need temp to make MS F77 Ver.5.00 to not optimize out loop
               temp = ibuf(slloop)
210         continue
         else
            do while (sl .lt. bsl(i))
               call diskio(9,11,ibuf,ifcb)
               if(ifcb(1).eq.-1) goto 998
               if(ifcb(1).lt.-1) call exit(4)
cver3               call unpack(ibuf,ifcb)
 
cver3               if(ofcb(25).eq.8) call pack(ibuf,ofcb)
               call diskio(10,12,ibuf,ofcb)
               if(ofcb(1).lt.0) call exit(5)
 
               sl = sl + 1
            enddo
cver3            call unpack(ibuf,ofcb)
            if(ofcb(25).eq.8) call unpack(ibuf,ofcb)
         endif
 
c  read past bad scanline / scanlines
 
         do 300 nbsli=1, nbsl(i) + 1
            call diskio(9,11,tbuf,ifcb)
            if(ifcb(1).eq.-1) goto 998
            if(ifcb(1).lt.-1) call exit(6)
c              if read hits EOF - output file has less sl than input
300      continue
 
cver3         call unpack(tbuf,ifcb)
         if(ofcb(25).eq.8) call unpack(tbuf,ifcb)
 
c  write linear interpolation
 
         do 400 nbsli=1, nbsl(i)
            do 410 pix=1, ifcb(2)
               t2buf(pix)=
     &            ibuf(pix)+((tbuf(pix)-ibuf(pix))*nbsli)/(nbsl(i)+1)
410         continue
            if(ofcb(25).eq.8) call pack(t2buf,ofcb)
            call diskio(10,12,t2buf,ofcb)
            if(ofcb(1).lt.0) call exit(7)
400      continue
 
c  write good scanline past bad zone
 
         if(ofcb(25).eq.8) call pack(tbuf,ofcb)
         call diskio(10,12,tbuf,ofcb)
         if(ofcb(1).lt.0) call exit(8)
 
c  set sl varable to current scanline
 
         sl = sl + nbsl(i) + 1
 
200   continue
 
c  finish writing rest of file
 
990   if (sl.le.ifcb(2)) then
         do 995 slloop=sl, ifcb(2)
            call diskio(9,11,ibuf,ifcb)
            if(ifcb(1).eq.-1) goto 998
            if(ifcb(1).lt.-1) call exit(4)
cver3            call unpack(ibuf,ifcb)
 
cver3            if(ofcb(25).eq.8) call pack(ibuf,ofcb)
            call diskio(10,12,ibuf,ofcb)
            if(ofcb(1).lt.0) call exit(5)
995      continue
      endif
 
c  finish
 
998   call diskio(6,11,ibuf,ifcb)
      call diskio(6,12,ibuf,ofcb)
 
      stop
      end
 
