      PROGRAM BANDRSQ
C ******************************************************
C *    FITS OBSERVED SPECTRA TO LIB SPECTRA
C *    CALC BAND DEPTH  - 256 CHANNEL MAX
C *                       614 PIXEL/SCANLINE MAX
C *
C *    BY K. ERIC LIVO
C *    YIELDS QUALITY ERROR OF FIT (R-square)
C *       and BAND DEPTH (Absorption strength)
C *    16 BIT DATA
C *
C *    LINK WITH DISKIO, PACK, UNPACK
C *
C ******************************************************
C
      INTEGER*4 IFCBI(256), IFCBK(256), IFCBBD(256)
      INTEGER*2 RO(256,614), IBUFI(614), IBUFK(614), IBUFBD(614)
      INTEGER*4 IPIX, IBANDST, IBANDEND, IBADCH
      INTEGER*4 N, IC(4), IBAND, I
      REAL*4 WAVELN(256), RL(256), RLC(256), R2, BD
      REAL*8 CLI, CL0, CL1, RLSUM
      CHARACTER*80 SPECNAME
C
C  START
C
      IBAND=256
C
C  LOGIT
C
      CALL REMLOG('******* BANDRSQ *******')
C
C  ENTER STARTING AND ENDING BANDS FOR CONTINUUM
C  INPUT AS INTEGERS
C
9     WRITE(6,10)
      write(4,10)
10    FORMAT(1X,'Enter the TWO Continuum STARTING Channels')
      READ(5,*) IC(1),IC(2)
      write(4,*) ic(1),ic(2)
      IBANDST=IC(2)
      WRITE(6,20)
      write(4,20)
20    FORMAT(1X,'Enter the TWO Continuum ENDING Channels')
      READ(5,*) IC(3),IC(4)
      write(4,*) ic(3), ic(4)
      IBANDEND=IC(3)
      N=IBANDEND-IBANDST+1
      IF(N .GT. IBAND) THEN
         WRITE(*,*) 'BAND INTERVAL ', N,' GREATER THAN', IBAND
         GOTO 9
      ENDIF
C  OPEN OBSERVED SPECTRA FILE
      IFCBI(1)=0
      WRITE(6,30)
      write(4,30)
30    FORMAT(1X,'Enter Imaging Spectrometry Data Filename')
      CALL DISKIO(0,11,IBUFI,IFCBI)
      IF(IFCBI(1).LT.0) CALL EXIT(12)
      IBAND=IFCBI(13)
C  OPEN LIBRARY SPECTRA FILE
      WRITE(6,35)
      write(4,35)
35    FORMAT(1X,'Enter ASCII Mineral Spectra Filename')
      READ(5,36) SPECNAME
      write(4,36) specname
36    FORMAT(A80)
      OPEN(UNIT=14,FILE=SPECNAME,FORM='FORMATTED',
     &STATUS='OLD', ACCESS='SEQUENTIAL', ERR=998)
C  READ SPECTRA TEXT (ASCII) FILE
      write(6,361) iband
      write(4,361) iband
361   format(1X,'Number of channels in BIL image: ',I6)
      DO 37 I=1, IBAND
      READ (14,*) WAVELN(I), RL(I)
37    CONTINUE
C  CALC AVERAGE STARTING AND ENDING RL's
      RLSUM = 0.
      DO 371 I=IC(1), IBANDST
         RLSUM = RLSUM + RL(I)
371   CONTINUE
      RL(IBANDST) = RLSUM / (IBANDST - IC(1) + 1)
      RLSUM = 0.
      DO 372 I=IBANDEND, IC(4)
         RLSUM = RLSUM + RL(I)
372   CONTINUE
      RL(IBANDEND) = RLSUM / (IBANDST - IC(1) + 1)
C  CALC CONTINUUM AND CORRECTED RLC()
      CL0=(RL(IBANDEND)-RL(IBANDST))/(IBANDEND-IBANDST)
      CL1=RL(IBANDST)-CL0*(IBANDST)
      WRITE(6,375)
      write(4,375)
375   FORMAT(1X,'Wavelength, Spectra, Continuum, Continuum Removed ',
     & 'Spectra')
      DO 38 I=IBANDST,IBANDEND
         CLI=CL0*(I) + CL1
         WRITE(6,41) WAVELN(I),RL(I),CLI,RL(I)/CLI
         write(4,41) WAVELN(I),RL(I),CLI,RL(I)/CLI
41       FORMAT(1X,4F11.4)
38    RLC(I)=RL(I)/CLI
      IF(RLC(I) .GT. 1.0) RLC(I)=1.0
C  ENTER any BAD CHANNELS
      IBADCH = -1
      DO WHILE(IBADCH .NE. 0)
382      WRITE(6,384)
         write(4,384)
384      FORMAT(1X,'ENTER BAD CHANNEL #: (<0> to end) ',\)
         READ(5,*) IBADCH
         write(4,*) IBADCH
         IF((IBADCH .NE. 0) .AND.
     &   ((IBADCH .LT. IBANDST) .OR. (IBADCH .GT. IBANDEND))) THEN
            WRITE(6,*) 'channel out of range - enter again'
            write(4,*) 'channel out of range - enter again'
            goto 382
         ENDIF
         IF (IBADCH .NE. 0) THEN 
            RLC(IBADCH) = -1.
            N = N - 1
         ENDIF
      ENDDO
C  OPEN RSQ OUTPUT FILE
      IFCBK(1)=8
      IFCBK(2)=IFCBI(2)
      IFCBK(13)=1
      WRITE(6,40)
      write(4,40)
40    FORMAT(1X,'ENTER GOODNESS OF FIT <RSQ> FILENAME')
      CALL DISKIO(0,12,IBUFK,IFCBK)
      IF(IFCBK(1).LT.0) CALL EXIT(13)
C  OPEN BD - BAND DEPTH OUTPUT FILE
      IFCBBD(1)=8
      IFCBBD(2)=IFCBI(2)
      IFCBBD(13)=1
      WRITE(6,45)
      write(4,45)
45    FORMAT(1X,'ENTER BAND DEPTH FILENAME')
      CALL DISKIO(0,13,IBUFBD,IFCBBD)
      IF(IFCBBD(1).LT.0) CALL EXIT(13)
C  ADVANCE RECORD POINTER TO 1ST BAND TO READ
      IFCBI(14)=IFCBI(14) + (IC(1) - 1)
C  SCANLINE SPECTRA SET LOOP
200   CONTINUE
C  START LOOP TO READ ALL PIXELS/SCANLINE
C
C  READ PIXEL SPECTRA INTO ARRAY
C   & THEN TRANSPOSE INTO PIXEL - CHANNEL CONTINUOUS ARRAY
C
      DO 47 I=IC(1), IC(4)
         CALL DISKIO(9,11,IBUFI,IFCBI)
         IF(IFCBI(25).EQ.8) CALL UNPACK(IBUFI,IFCBI)
         IF(IFCBI(I).LT.0) GOTO 999
         DO 48 IPIX=1, IFCBI(2)
            RO(I,IPIX)=IBUFI(IPIX)
48       CONTINUE
47    CONTINUE
C
C  START GOODNESS OF FIT FOR PIXEL IPIX
C  PASS ONLY LAB (MINERAL) AND OBSERVED (SCANNER) SPECTRA FOR SINGLE PIXEL
C
      DO 110 IPIX=1,IFCBI(2)

      CALL CLSPEC(WAVELN, RO(1,IPIX), RLC, IC, N, R2, BD)

      IBUFK(IPIX)=INT(R2*200.)
      IBUFBD(IPIX)=INT(BD*200.)
110   CONTINUE
C  WRITE R-SQUARE
      IF(IFCBK(25).EQ.8) CALL PACK(IBUFK,IFCBK)
      CALL DISKIO(10,12,IBUFK,IFCBK)
      IF(IFCBK(1).LT.0) GOTO 999
C  WRITE BAND DEPTH
      IF(IFCBBD(25).EQ.8) CALL PACK(IBUFBD,IFCBBD)
      CALL DISKIO(10,13,IBUFBD,IFCBBD)
      IF(IFCBBD(1).LT.0) CALL EXIT(13)
C  ADVANCE SPECTRA FILE TO NEXT SPECTRA SET OF SCANLINES
C  TOP OF BIL SET
      IFCBI(14)=IFCBI(14)+IFCBI(13) - (IC(4) - IC(1) + 1)
      IF(IFCBI(14).LT. IFCBI(26)) GOTO 200
      GOTO 999
C  ERROR MESSAGE FOR OPENING UNIT(14) [SPECNAME]
998   WRITE(6,990) SPECNAME
990   FORMAT(1X,A80,' NOT FOUND')
C  CLOSE FILES
999   CALL DISKIO(6,11,IBUFI,IFCBI)
      CALL DISKIO(6,12,IBUFK,IFCBK)
      CALL DISKIO(6,13,IBUFBD,IFCBBD)
      CLOSE(14)
      STOP
      END
            
      
      SUBROUTINE CLSPEC(WAVELN, RO, RLC, IC, N, R2, BD)
C  *********************************************************
C  FITS OBSERVED SPECTRA TO LIB SPECTRA
C
C  BY K. ERIC LIVO
C  YIELDS QUALITY ERROR OF FIT
C  16 BIT DATA
C
C  LAB SPECTRA SCALED TO LEAST SQUARES FIT OBSERVED SPECTRA
C  BAND DEPTH OF SCALED LAB SPECTRA
C  CENTER OF ABSORPTION BAND - MAX ABSORP. CHAN.
C
C  INPUT VARIABLES:
C     WAVELN(256)  WAVELENGTH ARRAY (MICRONS, ETC)  (REAL*4)
C     RO(256)      SPECTRA OF OBSERVED IMAGE PIXEL  (INT*2)
C     RLC(256)     SPECTRA OF LAB SAMPLE            (REAL*4)
C                     (CONTINUUM REMOVED)
C     IC(4):                                        ( INT*4)
C        IC(1) - IC(2)  LOW AND HIGH CHANNELS OF
C            STARTING POINT OF MATCHING INTERVAL
C        IC(3) - IC(4)  LOW AND HIGH CHANNELS OF
C            ENDING POINT OF MATCHING INTERVAL
C     N            NUMBER OF CHANNELS USED IN CURVE ( INT*4)
C                     MATCHING INTERVAL
C
C  OUTPUT VARIABLES:
C     R2           R-SQUARED QUALITY ERROR OF FIT   (REAL*4)
C                     RANGES FROM: PERFECT FIT = 1.
C                     NO FIT = 0.
C     BD           BAND DEPTH (IE: LOWEST OBSERVED  (REAL*4)
C                     VALUE IN MATCHING INTERVAL
C                     AFTER CONTINUUM CORRECTION)
C
C     B            SLOPE OF PREDICTED VALUE (scaled lab spectra)
C     A            INTERCEPT OF PREDICTED VALUE
C
C  *********************************************************
      REAL*8 B, B1, SOCLC, SOC, SLC, SLC2
      REAL*8 A, SST, SSR, RSQ, SOC2, ROCHAT, SROCH1, SROCH2
      INTEGER*4 I, IBANDST, IBANDEND, IC(4), N, ROSUM
      INTEGER*2 RO(256)
      REAL*4 WAVELN(256), RLC(256), R2, BD, COB
      REAL*8 CL0, CL1, CLI, ROC(256)
C
      BD=0.
      R2=0.
      SOCLC=0.
      SOC=0.
      SLC=0.
      SLC2=0.
      SOC2=0.
C  CALC ROC() - CONTINUUM CORRECTED
      IBANDST=IC(2)
      IBANDEND=IC(3)
C    CALC AVG START & END RO's
      ROSUM = 0
      DO 485 I=IC(1),IBANDST
         ROSUM = ROSUM + RO(I)
485   CONTINUE
      RO(IBANDST) = ROSUM / (IBANDST - IC(1) + 1)
      ROSUM = 0
      DO 489 I = IBANDEND, IC(4)
         ROSUM = ROSUM + RO(I)
489   CONTINUE
      RO(IBANDEND) = ROSUM / (IC(4) - IBANDEND + 1)
C  CL0 = SLOPE, CL1 = INTERCEPT: IBAND=0
      CL0=REAL(RO(IBANDEND)-RO(IBANDST))/(IBANDEND-IBANDST)
      CL1=REAL(RO(IBANDST))-CL0*(IBANDST)
      DO 50 I=IBANDST,IBANDEND
      CLI=CL0*(I) + CL1
      IF (CLI .LE. 0.000001) THEN
         ROC(I)=1.
      ELSE
         ROC(I)=REAL(RO(I))/CLI
      ENDIF
      IF(ROC(I) .GT. 1.0) ROC(I)=1.0
      IF(ROC(I) .LT. 0.000001) ROC(I)=0.0
50    CONTINUE
C
C  CALCULATE RSQ - GOODNESS OF FIT OF FITTED (PREDICTED)
C     LAB SPECTRA TO (REAL) OBSERVED SPECTRA
C
      DO 105 I=IBANDST,IBANDEND
         IF(RLC(I) .GE. 0.) THEN
            SOCLC=SOCLC+ROC(I)*RLC(I)
            SOC=SOC+ROC(I)
            SLC=SLC+RLC(I)
            SLC2=SLC2+RLC(I)*RLC(I)
            SOC2=SOC2+ROC(I)*ROC(I)
         ENDIF
105   CONTINUE
      B1=SLC2-((SLC*SLC)/N)
      IF(B1.LE. 0.000001) THEN
         R2 = 0.
      ELSE
         B=(SOCLC-((SLC*SOC)/N))/B1
         IF(B .LE. 0.) THEN
            R2 = 0.
         ELSE
            A=SOC/N - B*(SLC/N)
C           CALC PREDICTED CHANNEL VALUE (least squares linear eq.
C                                         which scales lab spectra)
            SROCH1=0.
            SROCH2=0.
            DO 106 I=IBANDST,IBANDEND
               IF(RLC(I) .GE. 0) THEN
                  ROCHAT=A+B*RLC(I)
C  MAX BAND DEPTH (of calc fit lab spectra) AND CHANNEL
                  IF(1. - ROCHAT .GT. BD) THEN
                     BD = 1. - ROCHAT
                     COB = WAVELN(I)
                  ENDIF
                  SROCH1=SROCH1+ROCHAT
                  SROCH2=SROCH2+ROCHAT*ROCHAT
               ENDIF
106         CONTINUE
            SSR=SROCH2 - (SROCH1*SROCH1)/N
            SST=SOC2-(SOC*SOC)/N
            IF(SST .LT. 0.000001) THEN
               R2=1.1
            ELSE
               RSQ=SSR/SST
               IF(RSQ .LT. 0.) RSQ=0.
               IF(RSQ .GT. 1.) RSQ=1.
               R2=RSQ
            ENDIF
         ENDIF
      ENDIF
      RETURN
      END
      
