      PROGRAM BOXFILTR
C ****************************************************************
C *                                                              *
C *  BOX FILTER: to turn ON Central PIXEL of BOX                 *
C *     to DN(BOXavg)  when COUNT >= threshold                   *
C *                                                              *
C *  ENTER:                                                      *
C *          N - number of pixels per side of box                *
C *          DN - threshold value >= counts pixel                *
C *          COUNT - minimum number of pixels counted            *
C *                  within box to set center pixel              *
C *                  DN to DN(BOXavg)  ie: SUM(DN)/(N*N)         *
C *                                                              *
C *          even numbered (N) pixels per side                   *
C *          top & left sides contains 1 extra blank line        *
C *                                                              *
C *      by K. Eric Livo      4/27/90                            *
C *                                                              *
C *                                                              *
C *  LINK WITH  DISKIO, PACK, UNPACK                             *
C *                                                              *
C ****************************************************************
C
      INTEGER*4 INFCB(256), OUTFCB(256)
      INTEGER*2 JBUF(8192)
      INTEGER*4 N, DN, COUNT, SLCOUNT, CENTERSL
      INTEGER*4 NHALF, IPIXEND, ISL, IPIX, TOTAL, IS, IP, ISUMDN, NSQ
      INTEGER*2 IBUF(8192,21)
C
C  LOG IT
C
      CALL REMLOG('========== BOX FILTER ==========')
C
C OPEN INPUT FILE
C
      INFCB(1) = 0
      CALL DISKIO(0,10,IBUF,INFCB)
      IF(INFCB(1).LT.0) CALL EXIT(3)
C
C OPEN OUTPUT FILE
C
      OUTFCB(1)=INFCB(25)
      OUTFCB(2)=INFCB(2)
      IF(INFCB(22).GT.1)THEN
         OUTFCB(13)=1
      ELSE
         OUTFCB(13)=INFCB(13)
      ENDIF
      CALL DISKIO(0,11,JBUF,OUTFCB)
      IF(OUTFCB(1).LT.0) CALL EXIT(4)
C
C  GET INITIAL VALUES
C
19    WRITE(6,20)
20    FORMAT(' N PIXELS/SIDE: (3-21) = '\)
      READ(5,30) N
30    FORMAT(I4)
         IF(N.LT.3) WRITE(6,*) 'MIN BOX SIZE IS 3 x 3'
         IF(N.GT.21) WRITE(6,*) 'MAX BOX SIZE IS 21 x 21'
         IF((N.LT.3) .OR. (N.GT.21)) GOTO 19
      WRITE(6,40)
40    FORMAT(' THRESHOLD DN = '\)
      READ(5,30) DN
59    WRITE(6,60)
60    FORMAT(' MIN PIXEL/BOX = '\)
      READ(5,30) COUNT
         IF(COUNT .GT. N*N) WRITE(6,*) 'MAX PIXEL/BOX # = ',N*N
         IF(COUNT .GT. N*N) GOTO 59
C
C  LOG INIT VALUES
C
      WRITE(4,10) N, DN, COUNT
10    FORMAT(1X,'N PIX:'I6,'  THRESHOLD DN:',I6,'  MIN PIX/BOX:',I6)
C
C  GET INTERMEDIATE VARS
C
      NHALF = N/2
      NSQ = N * N
      IPIXEND = INFCB(2) - N + 1
C
C  LOAD ARRAY BUFFER WITH N SCANLINES
C     & duplicate original unfiltered top scanlines
C
      DO 110, ISL = 1, N-1
         CALL DISKIO(9,10,IBUF(1,ISL),INFCB)
         IF (INFCB(1) .EQ. -1) GOTO 999
         IF (INFCB(1) .LT. -1) CALL EXIT(5)
         IF (ISL .LE. N/2) CALL DISKIO(10,11,IBUF(1,ISL),OUTFCB)
         IF(INFCB(25).EQ.8) CALL UNPACK(IBUF(1,ISL),INFCB)
110   CONTINUE
C
      SLCOUNT = N
C
C  TOP OF MAIN LOOP
C
115   CALL DISKIO(9,10,IBUF(1,SLCOUNT),INFCB)
      IF (INFCB(1) .EQ. -1) GOTO 999
      IF (INFCB(1) .LT. -1) CALL EXIT(5)
      IF (INFCB(25) .EQ. 8) CALL UNPACK(IBUF(1,SLCOUNT),INFCB)
C
C  SCANLINE PARSING
C
      DO 120, IPIX = 1, IPIXEND
         TOTAL = 0
         ISUMDN = 0
         DO 130, IP = IPIX, IPIX + N - 1
            DO 140, IS = 1, N
               IF(IBUF(IP,IS) .GE. DN) THEN
                  TOTAL = TOTAL + 1
                  ISUMDN = ISUMDN + IBUF(IP,IS)
               ENDIF
140         CONTINUE
130      CONTINUE
         IF(TOTAL .GE. COUNT) THEN
            JBUF(IPIX+NHALF) = ISUMDN/(NSQ)
         ELSE
            JBUF(IPIX+NHALF) = 0
         ENDIF
120   CONTINUE
C
C  GET UNFILTERED PIXEL EDGES
C
      CENTERSL = SLCOUNT - (N-1)/2
      IF(CENTERSL .LT. 1) CENTERSL = N + CENTERSL
      DO 200, ISC = 1, NHALF
         JBUF(ISC) = IBUF(ISC,CENTERSL)
200   CONTINUE
      DO 210, ISC = OUTFCB(2) - (N-1)/2 + 1, OUTFCB(2)
         JBUF(ISC) = IBUF(ISC,CENTERSL)
210   CONTINUE
C
C  WRITE OUTPUT SCANLINE
C
      IF(OUTFCB(25).EQ.8) CALL PACK(JBUF,OUTFCB)
      CALL DISKIO(10,11,JBUF,OUTFCB)
      IF(OUTFCB(1).LT.0) CALL EXIT(6)
C
C  INCREMENT ARRAY SCANLINE POINTER
C
      SLCOUNT = SLCOUNT + 1
      IF(SLCOUNT.GT.N) SLCOUNT = 1
C
C  LOOP TO START NEXT SCANLINE
C
      GOTO 115
C
C  WRITE LAST SPACING BLANK LINES
C
999   SLCOUNT = SLCOUNT - (N-1)/2
      IF(SLCOUNT .LT. 1) SLCOUNT = N + SLCOUNT
      DO 998, ISL=1, (N-1)/2
         IF(OUTFCB(25) .EQ. 8) CALL PACK(IBUF(1,SLCOUNT),OUTFCB)
         CALL DISKIO(10,11,IBUF(1,SLCOUNT),OUTFCB)
         SLCOUNT = SLCOUNT + 1
         IF(SLCOUNT .GT. N) SLCOUNT = 1
998   CONTINUE
C
C  FINISH PROGRAM
C
      CALL DISKIO(6,10,IBUF,INFCB)
      CALL DISKIO(6,11,JBUF,OUTFCB)
C
      STOP
      END
