      PROGRAM REMFLIP
C** *****************************************************************
C
C   REMAPP P-E 3220 1980
C   REMOTE SENSING ARRAY PROCESSING PROCEDURES
C   U. S. GEOLOGICAL SURVEY, DENVER, COLORADO
C   BRANCH OF PETROPHYSICS AND REMOTE SENSING
C   DON L. SAWATZKY
C
C   LINK WITH DISKIO
C
C   *****************************************************************
      INTEGER*4 IN(256),OUT(256)
      LOGICAL*1 IBUF(16384)
      DATA IN,OUT/512*0/
C
C  LOGIT
C
      CALL REMLOG('*******   REMFLIP   ******')
C
C  OPEN INPUT FILE
C
      IN(1)=0
      CALL DISKIO(0,10,IBUF,IN)
      IF(IN(1).LT.0) CALL EXIT(3)
C
C  OPEN OUTPUT FILE
C
      OUT(1)=IN(25)
      OUT(2)=IN(2)
      IF(IN(22).GT.1) THEN
         OUT(13)=1
      ELSE
         OUT(13)=IN(13)
      ENDIF
      CALL DISKIO(0,11,IBUF,OUT)
      IF(OUT(1).LT.0) CALL EXIT(3)
C
C.....READ,WRITE REVERSE LOOP
C
C     IN(14) = current absolute file record
C     IN(5) = starting absolute file record
C     IREC = [in(3)] - relative scanline within window  (1-EOF)
C     IN(22) = # bands when inputing single band of BIL image
C     IN(22) = 1 when inputting all bands of BIL or single band image
C
C     calc scanline skips entered
C
      ISLSKIP = (IN(7)+1)/IN(22) - 1
C
      DO 10 IREC=IN(3),1,-1
         IN(14)=((IREC-1) * (ISLSKIP+1)) * IN(22) + IN(5)
         CALL DISKIO(9,10,IBUF,IN)
         IF(IN(1).EQ.-1) GOTO 999
         IF(IN(1).LT.-1) CALL EXIT(3)
         CALL DISKIO(10,11,IBUF,OUT)
         IF(OUT(1).LT.0) CALL EXIT(4)
10    CONTINUE
C
C  CLOSE FILES
C
999   CALL DISKIO(6,10,IBUF,IN)
      CALL DISKIO(6,11,IBUF,OUT)
      STOP
      END
