      PROGRAM SPECAVG
C  ********************************************************
C  *  AVERAGES ANY NUMBER OF ASCII BIL CALIBRATION FILES  *
C  *  INTO ONE OUTPUT CAL. FILE                           *
C  *                                                      *
C  *  INPUT AND OUTPUT FILE FORMAT  (REAL CONSTANTS):     *
C  *     MULTIPLIER  ADDITION                             *
C  *                                                      *
C  *  BY K. Eric Livo                                     *
C  *                                                      *
C  *  3/12/91                                             *
C  ********************************************************
C
      INTEGER*4 I, NUM, CODE, BANDS, IBAND
      CHARACTER*80 FILENAME
      CHARACTER*1 RESPON
      REAL*4 MOUT(1024), AOUT(1024), SUMOUT, ADDOUT
      REAL*4 MULT(1024,32), ADD(1024,32)
C
C  OPEN INPUT FILES
C
      WRITE(6,70)
70    FORMAT(1X,'HOW MANY BANDS (BIL) IN THIS FILE '\)
      READ(5,*) BANDS
      NUM = 0
80    NUM = NUM + 1
      WRITE(6,100)
100   FORMAT(1X,'ASCII CALIBRATION INPUT FILE = '\)
      READ(5,110) FILENAME
110   FORMAT(80A)
      OPEN(11,FILE=FILENAME,ACCESS='SEQUENTIAL',FORM='FORMATTED',
     & MODE='READ',IOSTAT=CODE,STATUS='OLD')
      IF(CODE.NE.0) STOP 'OPEN I/O ERROR'
C
C  READ ASCII FILE
C
      DO 120 IBAND=1,BANDS
120         READ(11,*,ERR=998) MULT(IBAND,NUM), ADD(IBAND,NUM)
      CLOSE(11)
C
      WRITE(6,130)
130   FORMAT(1X,'READ ANOTHER ASCII FILE (Y/N): '\)
      READ(5,140) RESPON
140   FORMAT(A1)
C
      IF(((RESPON.EQ.'Y').OR.(RESPON.EQ.'y')).AND.(NUM.LT.32)) GOTO 80
C
      IF(NUM.GE.32) WRITE(6,*)
     & 'MAX NUMBER OF FILES ENTERED (32), PROCESSING CONTINUES'
C
      WRITE(6,*)
      WRITE(6,150)
150   FORMAT(1X,'ASCII CALIBRATION OUTPUT FILE = '\)
      READ(5,110) FILENAME
      OPEN(12,FILE=FILENAME,ACCESS='SEQUENTIAL',FORM='FORMATTED',
     & IOSTAT=CODE,STATUS='NEW')
      IF(CODE.NE.0) STOP 'OPEN I/O ERROR'
C
      DO 200 IBAND=1,BANDS
         SUMOUT = 0
         ADDOUT = 0
         DO 210 I=1,NUM
            SUMOUT = SUMOUT + MULT(IBAND,I)
            ADDOUT = ADDOUT + ADD(IBAND,I)
210      CONTINUE
         MOUT(IBAND) = SUMOUT / NUM
         AOUT(IBAND) = ADDOUT / NUM
         WRITE(12,215,ERR=990) MOUT(IBAND), AOUT(IBAND)
200   CONTINUE
215   FORMAT(2E21.8)
      GOTO 999
C
C  ERROR MESSAGES
C
990   WRITE(6,992)
992   FORMAT(1X,'ERROR WRITING ASCII FILE')
998   WRITE(6,995)
995   FORMAT(1X,'ERROR READING ASCII FILE')
C
C  FINISH
C
999   CLOSE(12)
      STOP
      END
