      PROGRAM STRIPHDR
C***********************************************************
C     BY K. ERIC LIVO
C     PROGRAM CREATES A REMAPP HEADER, DISCARDS A DEFINED
C          NUMBER OF BYTES FROM THE BEGINNING OF THE
C          NON-REMAPP INPUT IMAGE FILE (STRIPS HEADER), THEN
C          COPIES THE REMAINING DATA TO THE REMAPP OUTPUT
C          IMAGE FILE
C***********************************************************
c  LINK WITH DISKIO
      INTEGER*4 OUT(256),PIXEL,IBAND,J,CODE,NBITS,RECLEN
      INTEGER*4 NBYTES
      LOGICAL*1 IBUF(16384)
      CHARACTER*80 FILENAME
      DATA OUT/3*0,2*1,251*0/
      CODE=0
C
      CALL REMLOG('=========== STRIPHDR ===========')
C
      WRITE(6,22)
22    FORMAT(1X,'INPUT FILENAME = ',\)
      READ(5,20) FILENAME
20    FORMAT(80A)
      WRITE(6,23)
23    FORMAT(1X,'PIXELS per SCANLINE = ',\)
      READ(5,*) PIXEL
      WRITE(6,25)
25    FORMAT(1X,'NO. BITS per PIXEL = ',\)
      READ(5,*) NBITS
      RECLEN=PIXEL*(NBITS/8)
      WRITE(6,30)
30    FORMAT(1X,'NO. BYTES to SKIP at START = ',\)
      READ(5,*) NBYTES
C
      OPEN(10,ACCESS='SEQUENTIAL',FILE=FILENAME,
     &FORM='BINARY',MODE='READ',IOSTAT=CODE,STATUS='OLD')
      WRITE(6,24)
24    FORMAT(1X,'No. BANDS = ',\)
      READ(5,*) IBAND
      OUT(1)=NBITS
      OUT(2)=PIXEL
      OUT(13)=IBAND
      CALL DISKIO(0,11,IBUF,OUT)
      IF(OUT(1).LT.0) CALL EXIT(3)
C
C  SKIP NBYTES (NON-REMAPP HEADER)
C
      READ(10,IOSTAT=CODE) (IBUF(J),J=1,NBYTES)
C
C  START READ-WRITE LOOP
C
1     READ(10,IOSTAT=CODE) (IBUF(J),J=1,RECLEN)
      IF(CODE.NE.0) GOTO 2
      CALL DISKIO(10,11,IBUF,OUT)
      IF(OUT(1).LT.0) CALL EXIT(3)
      GOTO 1
C
2     CLOSE(10)
      CALL DISKIO(6,11,IBUF,OUT)
      WRITE(6,*) 'SCANLINES WRITTEN = ', OUT(3)
C
      STOP
      END
