      PROGRAM MUNSEL
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C      MUNSEL.FOR
C
C      PROGRAM TO PRODUCE HUE, VALUE, AND SATUARATION
C      IMAGES FROM INPUT IMAGE DN'S.
C      ASSUMES A COLOR ADDITIVE TECHNIQUE.
C
C      COLOR-SUBTRACTIVE PRIMARIES      COLOR-ADDITIVE PRIMARIES
C            CYAN---------------------------RED
C            MAGENTA------------------------GREEN
C
C      EQUATIONS DERIVED BY DON SAWATZKY, 14OCT76, AND
C      PROGRAM WRITTEN BY GARY RAINES.
C      DATE:  15OCT76
C
C      Program fixed for equal values of red/grn/blu nov 89, S. Miller
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C  LINK WITH DISKIO, UNPACK
      INTEGER*2 IRED(8192),IGRN(8192),IBLU(8192)
      INTEGER*2 IHUE[FAR](8192)
      INTEGER*2 ISAT[FAR](8192)
      INTEGER*2 IVAL[FAR](8192)
      INTEGER*4 FRED(256),FGRN(256),FBLU(256)
      INTEGER*4 FHUE(256),FSAT(256),FVAL(256)
      INTEGER*4 LINES,I,IOERROR
      REAL*4 K2,K6,K7,K3
      REAL*4 B1,X1,V1,BLU,GRN,RED,TMP,PIE,HUE,RSAT
      DATA FHUE,FSAT,FVAL/768*0/
      DATA FRED,FGRN,FBLU/768*0/
      K2=SQRT(2.)/2.
      K6=SQRT(6.)/6.
      K3=SQRT(3.)/3.
      K7=SQRT(6.)/3.
      LINES=0
      IOERROR=12
      PIE=3.14159265358979323846
      CALL REMLOG('*****   MUNSEL   *****')
C...OPEN 3 INPUT FILES OF COLOR-ADDITIVE DN'S
      WRITE(4,5)
5      FORMAT(2X,' RED, GREEN, AND BLUE INPUT FILES.')
      WRITE(6,10)
10      FORMAT(2X,'OPEN RED FILE, (CYAN).')
      CALL DISKIO(0,8,IRED,FRED)
      IF(FRED(1).LT.0) CALL EXIT(IOERROR)
      WRITE(6,20)
20      FORMAT(2X,'OPEN GREEN FILE, (MAGENTA).')
      CALL DISKIO(0,12,IGRN,FGRN)
      IF(FGRN(1).LT.0) CALL EXIT(IOERROR)
      WRITE(6,30)
30      FORMAT(2X,'OPEN BLUE FILE, (YELLOW).')
      CALL DISKIO(0,13,IBLU,FBLU)
      IF(FBLU(1).LT.0) CALL EXIT(IOERROR)
C...OPEN OUTPUT FILE FOR COLOR-CLASSIFIED IMAGES
      FHUE(1)=16
      FHUE(2)=FRED(2)
      FHUE(13)=1
      FSAT(1)=16
      FSAT(2)=FRED(2)
      FSAT(13)=1
      FVAL(1)=16
      FVAL(2)=FRED(2)
      FVAL(13)=1
      WRITE(4,34)
34      FORMAT(2X,' HUE, SATURATION, AND VALUE OUTPUT FILES.')
      WRITE(6,35)
35      FORMAT(2X,'OPEN OUTPUT HUE FILE.')
      CALL DISKIO(0,14,IHUE,FHUE)
      IF(FHUE(1).LT.0) CALL EXIT(IOERROR)
      WRITE(6,36)
36      FORMAT(2X,'OPEN OUTPUT SATURATION FILE.')
      CALL DISKIO(0,15,ISAT,FSAT)
      IF(FSAT(1).LT.0) CALL EXIT(IOERROR)
      WRITE(6,37)
37      FORMAT(2X,'OPEN OUTPUT VALUE FILE.')
      CALL DISKIO(0,16,IVAL,FVAL)
      IF(FVAL(1).LT.0) CALL EXIT(IOERROR)
C...READ A SCAN LINE TO OPERATE ON
40      CALL DISKIO(9,8,IRED,FRED)
      IF(FRED(1).LT.0) GOTO 999
      IF(FRED(25).EQ.8) CALL UNPACK(IRED,FRED)
      CALL DISKIO(9,12,IGRN,FGRN)
      IF(FGRN(1).LT.0) GOTO 999
      IF(FGRN(25).EQ.8) CALL UNPACK(IGRN,FGRN)
      CALL DISKIO(9,13,IBLU,FBLU)
      IF(FBLU(1).LT.0) GOTO 999
      IF(FBLU(25).EQ.8) CALL UNPACK(IBLU,FBLU)
      I=1
45      RED=IRED(I)
      GRN=IGRN(I)
      BLU=IBLU(I)
C...CALCULATE MUNSELL COORDINATES
      B1=K7*BLU-K6*GRN-K6*RED
      X1=K2*GRN-K2*RED
      V1=K3*(BLU+GRN+RED)
      TMP=B1*B1+X1*X1
      RSAT=SQRT(TMP)
      ISAT(I)=RSAT+0.5
      IVAL(I)=V1+0.5
      IF(RSAT .LT. 0.000001) GO TO 170
      HUE=ATAN2(X1,B1)
      HUE=HUE*180./PIE
      IF(HUE.LT.0) HUE=360.+HUE
      IHUE(I)=HUE+0.5
      GO TO 91
C...ALL DN'S EQUAL AND SATURATION=0
170      IHUE(I)=400.
91      I=I+1
      IF(I.LE.FRED(2)) GO TO 45
C...WRITE A COLOR CLASSIFIED SCAN LINE
      CALL DISKIO(10,14,IHUE,FHUE)
      CALL DISKIO(10,15,ISAT,FSAT)
      CALL DISKIO(10,16,IVAL,FVAL)
      LINES=LINES+1
C      WRITE(6,*)' LINE ',LINES,' WRITTEN.'
      IF(LINES.LT.FRED(3)) GO TO 40
C...CLOSE FILES
999   CALL DISKIO(6,8,IRED,FRED)
      CALL DISKIO(6,12,IGRN,FGRN)
      CALL DISKIO(6,13,IBLU,FBLU)
      CALL DISKIO(6,14,IHUE,FHUE)
      CALL DISKIO(6,15,ISAT,FSAT)
      CALL DISKIO(6,16,IVAL,FVAL)
      STOP
      END
